#include <rpc/rpc.h>
#include <sys/time.h>
#include "rex.h"
#ifndef lint
/*static char sccsid[] = "from: @(#)rex.x 1.3 87/09/18 Copyr 1987 Sun Micro";*/
/*static char sccsid[] = "from: @(#)rex.x	2.1 88/08/01 4.0 RPCSRC";*/
static char rcsid[] = "$Id: rex.x,v 1.1 1994/08/04 19:01:49 wollman Exp $";
#endif /* not lint */

/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };

rex_result *
rexproc_start_1(argp, clnt)
	rex_start *argp;
	CLIENT *clnt;
{
	static rex_result res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, REXPROC_START, xdr_rex_start, argp, xdr_rex_result, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


rex_result *
rexproc_wait_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static rex_result res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, REXPROC_WAIT, xdr_void, argp, xdr_rex_result, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


void *
rexproc_modes_1(argp, clnt)
	rex_ttymode *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, REXPROC_MODES, xdr_rex_ttymode, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}


void *
rexproc_winch_1(argp, clnt)
	rex_ttysize *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, REXPROC_WINCH, xdr_rex_ttysize, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}


void *
rexproc_signal_1(argp, clnt)
	int *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, REXPROC_SIGNAL, xdr_int, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}

