#include <stdio.h>
#include <rpc/rpc.h>
#include "rex.h"
#ifndef lint
/*static char sccsid[] = "from: @(#)rex.x 1.3 87/09/18 Copyr 1987 Sun Micro";*/
/*static char sccsid[] = "from: @(#)rex.x	2.1 88/08/01 4.0 RPCSRC";*/
static char rcsid[] = "$Id: rex.x,v 1.1 1994/08/04 19:01:49 wollman Exp $";
#endif /* not lint */

static void rexprog_1();

main()
{
	SVCXPRT *transp;

	(void)pmap_unset(REXPROG, REXVERS);

	transp = svcudp_create(RPC_ANYSOCK);
	if (transp == NULL) {
		(void)fprintf(stderr, "cannot create udp service.\n");
		exit(1);
	}
	if (!svc_register(transp, REXPROG, REXVERS, rexprog_1, IPPROTO_UDP)) {
		(void)fprintf(stderr, "unable to register (REXPROG, REXVERS, udp).\n");
		exit(1);
	}

	transp = svctcp_create(RPC_ANYSOCK, 0, 0);
	if (transp == NULL) {
		(void)fprintf(stderr, "cannot create tcp service.\n");
		exit(1);
	}
	if (!svc_register(transp, REXPROG, REXVERS, rexprog_1, IPPROTO_TCP)) {
		(void)fprintf(stderr, "unable to register (REXPROG, REXVERS, tcp).\n");
		exit(1);
	}
	svc_run();
	(void)fprintf(stderr, "svc_run returned\n");
	exit(1);
}

static void
rexprog_1(rqstp, transp)
	struct svc_req *rqstp;
	SVCXPRT *transp;
{
	union {
		rex_start rexproc_start_1_arg;
		rex_ttymode rexproc_modes_1_arg;
		rex_ttysize rexproc_winch_1_arg;
		int rexproc_signal_1_arg;
	} argument;
	char *result;
	bool_t (*xdr_argument)(), (*xdr_result)();
	char *(*local)();

	switch (rqstp->rq_proc) {
	case NULLPROC:
		(void)svc_sendreply(transp, xdr_void, (char *)NULL);
		return;

	case REXPROC_START:
		xdr_argument = xdr_rex_start;
		xdr_result = xdr_rex_result;
		local = (char *(*)()) rexproc_start_1;
		break;

	case REXPROC_WAIT:
		xdr_argument = xdr_void;
		xdr_result = xdr_rex_result;
		local = (char *(*)()) rexproc_wait_1;
		break;

	case REXPROC_MODES:
		xdr_argument = xdr_rex_ttymode;
		xdr_result = xdr_void;
		local = (char *(*)()) rexproc_modes_1;
		break;

	case REXPROC_WINCH:
		xdr_argument = xdr_rex_ttysize;
		xdr_result = xdr_void;
		local = (char *(*)()) rexproc_winch_1;
		break;

	case REXPROC_SIGNAL:
		xdr_argument = xdr_int;
		xdr_result = xdr_void;
		local = (char *(*)()) rexproc_signal_1;
		break;

	default:
		svcerr_noproc(transp);
		return;
	}
	bzero((char *)&argument, sizeof(argument));
	if (!svc_getargs(transp, xdr_argument, &argument)) {
		svcerr_decode(transp);
		return;
	}
	result = (*local)(&argument, rqstp);
	if (result != NULL && !svc_sendreply(transp, xdr_result, result)) {
		svcerr_systemerr(transp);
	}
	if (!svc_freeargs(transp, xdr_argument, &argument)) {
		(void)fprintf(stderr, "unable to free arguments\n");
		exit(1);
	}
}

