#include <rpc/rpc.h>
#include <sys/time.h>
#include "yp.h"
#ifndef lint
/*static char sccsid[] = "from: @(#)YP.x	2.1 88/08/01 4.0 RPCSRC";*/
static char rcsid[] = "$Id: YP.x,v 1.1 1994/08/04 19:01:55 wollman Exp $";
#endif /* not lint */

/* Default timeout can be changed using clnt_control() */
static struct timeval TIMEOUT = { 25, 0 };

void *
ypproc_null_2(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_NULL, xdr_void, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}


bool_t *
ypproc_domain_2(argp, clnt)
	domainname *argp;
	CLIENT *clnt;
{
	static bool_t res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_DOMAIN, xdr_domainname, argp, xdr_bool, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


bool_t *
ypproc_domain_nonack_2(argp, clnt)
	domainname *argp;
	CLIENT *clnt;
{
	static bool_t res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_DOMAIN_NONACK, xdr_domainname, argp, xdr_bool, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_val *
ypproc_match_2(argp, clnt)
	YPreq_key *argp;
	CLIENT *clnt;
{
	static YPresp_val res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_MATCH, xdr_YPreq_key, argp, xdr_YPresp_val, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_key_val *
ypproc_first_2(argp, clnt)
	YPreq_key *argp;
	CLIENT *clnt;
{
	static YPresp_key_val res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_FIRST, xdr_YPreq_key, argp, xdr_YPresp_key_val, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_key_val *
ypproc_next_2(argp, clnt)
	YPreq_key *argp;
	CLIENT *clnt;
{
	static YPresp_key_val res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_NEXT, xdr_YPreq_key, argp, xdr_YPresp_key_val, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_xfr *
ypproc_xfr_2(argp, clnt)
	YPreq_xfr *argp;
	CLIENT *clnt;
{
	static YPresp_xfr res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_XFR, xdr_YPreq_xfr, argp, xdr_YPresp_xfr, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


void *
ypproc_clear_2(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_CLEAR, xdr_void, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}


YPresp_all *
ypproc_all_2(argp, clnt)
	YPreq_nokey *argp;
	CLIENT *clnt;
{
	static YPresp_all res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_ALL, xdr_YPreq_nokey, argp, xdr_YPresp_all, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_master *
ypproc_master_2(argp, clnt)
	YPreq_nokey *argp;
	CLIENT *clnt;
{
	static YPresp_master res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_MASTER, xdr_YPreq_nokey, argp, xdr_YPresp_master, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_order *
ypproc_order_2(argp, clnt)
	YPreq_nokey *argp;
	CLIENT *clnt;
{
	static YPresp_order res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_ORDER, xdr_YPreq_nokey, argp, xdr_YPresp_order, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


YPresp_maplist *
ypproc_maplist_2(argp, clnt)
	domainname *argp;
	CLIENT *clnt;
{
	static YPresp_maplist res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPROC_MAPLIST, xdr_domainname, argp, xdr_YPresp_maplist, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


void *
yppushproc_null_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPUSHPROC_NULL, xdr_void, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}


YPpushresp_xfr *
yppushproc_xfrresp_1(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static YPpushresp_xfr res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPPUSHPROC_XFRRESP, xdr_void, argp, xdr_YPpushresp_xfr, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


void *
ypbindproc_null_2(argp, clnt)
	void *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPBINDPROC_NULL, xdr_void, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}


YPbind_resp *
ypbindproc_domain_2(argp, clnt)
	domainname *argp;
	CLIENT *clnt;
{
	static YPbind_resp res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPBINDPROC_DOMAIN, xdr_domainname, argp, xdr_YPbind_resp, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return (&res);
}


void *
ypbindproc_setdom_2(argp, clnt)
	YPbind_setdom *argp;
	CLIENT *clnt;
{
	static char res;

	bzero((char *)&res, sizeof(res));
	if (clnt_call(clnt, YPBINDPROC_SETDOM, xdr_YPbind_setdom, argp, xdr_void, &res, TIMEOUT) != RPC_SUCCESS) {
		return (NULL);
	}
	return ((void *)&res);
}

