#include <rpc/rpc.h>
#include "yp.h"
#ifndef lint
/*static char sccsid[] = "from: @(#)YP.x	2.1 88/08/01 4.0 RPCSRC";*/
static char rcsid[] = "$Id: YP.x,v 1.1 1994/08/04 19:01:55 wollman Exp $";
#endif /* not lint */


bool_t
xdr_YPstat(xdrs, objp)
	XDR *xdrs;
	YPstat *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPxfrstat(xdrs, objp)
	XDR *xdrs;
	YPxfrstat *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_domainname(xdrs, objp)
	XDR *xdrs;
	domainname *objp;
{
	if (!xdr_string(xdrs, objp, YPMAXDOMAIN)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_mapname(xdrs, objp)
	XDR *xdrs;
	mapname *objp;
{
	if (!xdr_string(xdrs, objp, YPMAXMAP)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_peername(xdrs, objp)
	XDR *xdrs;
	peername *objp;
{
	if (!xdr_string(xdrs, objp, YPMAXPEER)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_keydat(xdrs, objp)
	XDR *xdrs;
	keydat *objp;
{
	if (!xdr_bytes(xdrs, (char **)&objp->keydat_val, (u_int *)&objp->keydat_len, YPMAXRECORD)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_valdat(xdrs, objp)
	XDR *xdrs;
	valdat *objp;
{
	if (!xdr_bytes(xdrs, (char **)&objp->valdat_val, (u_int *)&objp->valdat_len, YPMAXRECORD)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPmap_parms(xdrs, objp)
	XDR *xdrs;
	YPmap_parms *objp;
{
	if (!xdr_domainname(xdrs, &objp->domain)) {
		return (FALSE);
	}
	if (!xdr_mapname(xdrs, &objp->map)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->ordernum)) {
		return (FALSE);
	}
	if (!xdr_peername(xdrs, &objp->peer)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPreq_key(xdrs, objp)
	XDR *xdrs;
	YPreq_key *objp;
{
	if (!xdr_domainname(xdrs, &objp->domain)) {
		return (FALSE);
	}
	if (!xdr_mapname(xdrs, &objp->map)) {
		return (FALSE);
	}
	if (!xdr_keydat(xdrs, &objp->key)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPreq_nokey(xdrs, objp)
	XDR *xdrs;
	YPreq_nokey *objp;
{
	if (!xdr_domainname(xdrs, &objp->domain)) {
		return (FALSE);
	}
	if (!xdr_mapname(xdrs, &objp->map)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPreq_xfr(xdrs, objp)
	XDR *xdrs;
	YPreq_xfr *objp;
{
	if (!xdr_YPmap_parms(xdrs, &objp->map_parms)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->transid)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->prog)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->port)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_val(xdrs, objp)
	XDR *xdrs;
	YPresp_val *objp;
{
	if (!xdr_YPstat(xdrs, &objp->stat)) {
		return (FALSE);
	}
	if (!xdr_valdat(xdrs, &objp->val)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_key_val(xdrs, objp)
	XDR *xdrs;
	YPresp_key_val *objp;
{
	if (!xdr_YPstat(xdrs, &objp->stat)) {
		return (FALSE);
	}
	if (!xdr_keydat(xdrs, &objp->key)) {
		return (FALSE);
	}
	if (!xdr_valdat(xdrs, &objp->val)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_master(xdrs, objp)
	XDR *xdrs;
	YPresp_master *objp;
{
	if (!xdr_YPstat(xdrs, &objp->stat)) {
		return (FALSE);
	}
	if (!xdr_peername(xdrs, &objp->peer)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_order(xdrs, objp)
	XDR *xdrs;
	YPresp_order *objp;
{
	if (!xdr_YPstat(xdrs, &objp->stat)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->ordernum)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_all(xdrs, objp)
	XDR *xdrs;
	YPresp_all *objp;
{
	if (!xdr_bool(xdrs, &objp->more)) {
		return (FALSE);
	}
	switch (objp->more) {
	case TRUE:
		if (!xdr_YPresp_key_val(xdrs, &objp->YPresp_all_u.val)) {
			return (FALSE);
		}
		break;
	case FALSE:
		break;
	default:
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_xfr(xdrs, objp)
	XDR *xdrs;
	YPresp_xfr *objp;
{
	if (!xdr_u_int(xdrs, &objp->transid)) {
		return (FALSE);
	}
	if (!xdr_YPxfrstat(xdrs, &objp->xfrstat)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPmaplist(xdrs, objp)
	XDR *xdrs;
	YPmaplist *objp;
{
	if (!xdr_mapname(xdrs, &objp->map)) {
		return (FALSE);
	}
	if (!xdr_pointer(xdrs, (char **)&objp->next, sizeof(YPmaplist), xdr_YPmaplist)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPresp_maplist(xdrs, objp)
	XDR *xdrs;
	YPresp_maplist *objp;
{
	if (!xdr_YPstat(xdrs, &objp->stat)) {
		return (FALSE);
	}
	if (!xdr_pointer(xdrs, (char **)&objp->maps, sizeof(YPmaplist), xdr_YPmaplist)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPpush_status(xdrs, objp)
	XDR *xdrs;
	YPpush_status *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPpushresp_xfr(xdrs, objp)
	XDR *xdrs;
	YPpushresp_xfr *objp;
{
	if (!xdr_u_int(xdrs, &objp->transid)) {
		return (FALSE);
	}
	if (!xdr_YPpush_status(xdrs, &objp->status)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPbind_resptype(xdrs, objp)
	XDR *xdrs;
	YPbind_resptype *objp;
{
	if (!xdr_enum(xdrs, (enum_t *)objp)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPbind_binding(xdrs, objp)
	XDR *xdrs;
	YPbind_binding *objp;
{
	if (!xdr_opaque(xdrs, objp->YPbind_binding_addr, 4)) {
		return (FALSE);
	}
	if (!xdr_opaque(xdrs, objp->YPbind_binding_port, 2)) {
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPbind_resp(xdrs, objp)
	XDR *xdrs;
	YPbind_resp *objp;
{
	if (!xdr_YPbind_resptype(xdrs, &objp->YPbind_status)) {
		return (FALSE);
	}
	switch (objp->YPbind_status) {
	case YPBIND_FAIL_VAL:
		if (!xdr_u_int(xdrs, &objp->YPbind_resp_u.YPbind_error)) {
			return (FALSE);
		}
		break;
	case YPBIND_SUCC_VAL:
		if (!xdr_YPbind_binding(xdrs, &objp->YPbind_resp_u.YPbind_bindinfo)) {
			return (FALSE);
		}
		break;
	default:
		return (FALSE);
	}
	return (TRUE);
}




bool_t
xdr_YPbind_setdom(xdrs, objp)
	XDR *xdrs;
	YPbind_setdom *objp;
{
	if (!xdr_domainname(xdrs, &objp->YPsetdom_domain)) {
		return (FALSE);
	}
	if (!xdr_YPbind_binding(xdrs, &objp->YPsetdom_binding)) {
		return (FALSE);
	}
	if (!xdr_u_int(xdrs, &objp->YPsetdom_vers)) {
		return (FALSE);
	}
	return (TRUE);
}


